package com.yice.webadmin.app.controller;

import com.yice.common.log.annotation.OperationLog;
import com.yice.common.log.model.constant.SysOperationLogType;
import com.github.pagehelper.page.PageMethod;
import com.yice.webadmin.app.vo.*;
import com.yice.webadmin.app.dto.*;
import com.yice.webadmin.app.model.*;
import com.yice.webadmin.app.service.*;
import com.yice.common.core.object.*;
import com.yice.common.core.util.*;
import com.yice.common.core.constant.*;
import com.yice.common.core.annotation.MyRequestBody;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import io.swagger.annotations.Api;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.*;

/**
 * 模型广场操作控制器类。
 *
 * @author linking
 * @date 2023-04-13
 */
@Api(tags = "模型广场管理接口")
@Slf4j
@RestController
@RequestMapping("/admin/app/modelSquare")
public class ModelSquareController {

    @Autowired
    private ModelSquareService modelSquareService;

    /**
     * 新增模型广场数据。
     *
     * @param modelSquareDto 新增对象。
     * @return 应答结果对象，包含新增对象主键Id。
     */
    @ApiOperationSupport(ignoreParameters = {"modelSquareDto.modelId", "modelSquareDto.searchString"})
    @OperationLog(type = SysOperationLogType.ADD)
    @PostMapping("/add")
    public ResponseResult<Long> add(@MyRequestBody ModelSquareDto modelSquareDto) {
        String errorMessage = MyCommonUtil.getModelValidationError(modelSquareDto, false);
        if (errorMessage != null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        ModelSquare modelSquare = MyModelUtil.copyTo(modelSquareDto, ModelSquare.class);
        modelSquare = modelSquareService.saveNew(modelSquare);
        return ResponseResult.success(modelSquare.getModelId());
    }

    /**
     * 更新模型广场数据。
     *
     * @param modelSquareDto 更新对象。
     * @return 应答结果对象。
     */
    @ApiOperationSupport(ignoreParameters = {"modelSquareDto.searchString"})
    @OperationLog(type = SysOperationLogType.UPDATE)
    @PostMapping("/update")
    public ResponseResult<Void> update(@MyRequestBody ModelSquareDto modelSquareDto) {
        String errorMessage = MyCommonUtil.getModelValidationError(modelSquareDto, true);
        if (errorMessage != null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        ModelSquare modelSquare = MyModelUtil.copyTo(modelSquareDto, ModelSquare.class);
        ModelSquare originalModelSquare = modelSquareService.getById(modelSquare.getModelId());
        if (originalModelSquare == null) {
            // NOTE: 修改下面方括号中的话述
            errorMessage = "数据验证失败，当前 [数据] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        if (!modelSquareService.update(modelSquare, originalModelSquare)) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        return ResponseResult.success();
    }

    /**
     * 删除模型广场数据。
     *
     * @param modelId 删除对象主键Id。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.DELETE)
    @PostMapping("/delete")
    public ResponseResult<Void> delete(@MyRequestBody Long modelId) {
        if (MyCommonUtil.existBlankArgument(modelId)) {
            return ResponseResult.error(ErrorCodeEnum.ARGUMENT_NULL_EXIST);
        }
        return this.doDelete(modelId);
    }

    /**
     * 列出符合过滤条件的模型广场列表。
     *
     * @param modelSquareDtoFilter 过滤对象。
     * @param orderParam 排序参数。
     * @param pageParam 分页参数。
     * @return 应答结果对象，包含查询结果集。
     */
    @PostMapping("/list")
    public ResponseResult<MyPageData<ModelSquareVo>> list(
            @MyRequestBody ModelSquareDto modelSquareDtoFilter,
            @MyRequestBody MyOrderParam orderParam,
            @MyRequestBody MyPageParam pageParam) {
        if (pageParam != null) {
            PageMethod.startPage(pageParam.getPageNum(), pageParam.getPageSize());
        }
        ModelSquare modelSquareFilter = MyModelUtil.copyTo(modelSquareDtoFilter, ModelSquare.class);
        String orderBy = MyOrderParam.buildOrderBy(orderParam, ModelSquare.class);
        List<ModelSquare> modelSquareList =
                modelSquareService.getModelSquareListWithRelation(modelSquareFilter, orderBy);
        return ResponseResult.success(MyPageUtil.makeResponseData(modelSquareList, ModelSquare.INSTANCE));
    }

    /**
     * 查看指定模型广场对象详情。
     *
     * @param modelId 指定对象主键Id。
     * @return 应答结果对象，包含对象详情。
     */
    @GetMapping("/view")
    public ResponseResult<ModelSquareVo> view(@RequestParam Long modelId) {
        ModelSquare modelSquare = modelSquareService.getByIdWithRelation(modelId, MyRelationParam.full());
        if (modelSquare == null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        ModelSquareVo modelSquareVo = ModelSquare.INSTANCE.fromModel(modelSquare);
        return ResponseResult.success(modelSquareVo);
    }

    private ResponseResult<Void> doDelete(Long modelId) {
        String errorMessage;
        // 验证关联Id的数据合法性
        ModelSquare originalModelSquare = modelSquareService.getById(modelId);
        if (originalModelSquare == null) {
            // NOTE: 修改下面方括号中的话述
            errorMessage = "数据验证失败，当前 [对象] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        if (!modelSquareService.remove(modelId)) {
            errorMessage = "数据操作失败，删除的对象不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        return ResponseResult.success();
    }
}
